library HudWeaponGroups;

{$R *.res}

uses
  Hud,
  Core,
  Winapi.Windows,
  Winapi.DXTypes;

type
  THudWeaponGroups = class(TInterfacedObject, IHud)
  private
    Owner    : TControl;
    Group    : array [0..2] of TButton;
    Shift    : Boolean;
    Delta    : Single;
    dxGroup  : Single;
  private
    procedure Reset;
    function Find(const Sender:TControl;const Name:AnsiString;out Target):Boolean;
  public
    constructor Create;
    procedure Draw(const Sender:TControl);stdcall;
    procedure Update(const Sender:TControl);stdcall;
    procedure Execute(const Sender:TControl);stdcall;
    procedure Terminate(const Sender:TControl);stdcall;
  end;

const
  CurrentShip  : PUINT = PUINT($679744);
  CurrentGroup : PByte = PByte($674C34);

constructor THudWeaponGroups.Create;
const
P1 = $4DB6A5;
P2 = $4DB6B7;
var
ini : TINI_Reader;
old : DWORD;
begin
with ini do
begin
  Create;
  if open('../data/interface/HudShift.ini') then
    while read_header do
      if is_header('HUDShift') then
      begin
        while read_value do
          if is_value('HudWeaponGroups') then
          begin
            Shift := get_value_bool(0);
            Break;
          end;
        Break;
      end;
  Destroy;
end;
if VirtualProtect(Pointer(P1),1,PAGE_EXECUTE_READWRITE,old) and
   VirtualProtect(Pointer(P2),2,PAGE_EXECUTE_READWRITE,old) then
   begin
    PByte(P1)^ := $07;
    PByte(P2+0)^ := $6A;
    PByte(P2+1)^ := $00;
   end;
end;

procedure THudWeaponGroups.Reset;
begin
Owner := nil;
Group[0] := nil;
Group[1] := nil;
Group[2] := nil;
dxGroup := 0.03;
end;

function THudWeaponGroups.Find(const Sender:TControl;const Name:AnsiString;out Target):Boolean;
var
Control : TControl absolute Target;
begin
if Assigned(Sender) and Sender.IsName('HUD_Status') then
begin
  Control := Sender.Child;
  while Control<>nil do
  begin
    if Control.IsName(Name) then Exit(True);
    Control := Control.Next;
  end;
end;
Result := False;
end;

procedure THudWeaponGroups.Draw(const Sender:TControl);
var
I       : Integer;
Pos     : TD3DVector;
Model   : PAnsiChar;
Battery : TControl;
begin
if (Owner = nil) and Sender.IsName('HUD_Status') then
  if Find(Sender,'BatteryCountText',Battery) then
  begin
    Reset;
    Owner := Sender;
    for I := 0 to High(Group) do
    begin
      case I of
      0: Model := 'INTERFACE\HUD\HUD_weaponsgroup1.3db';
      1: Model := 'INTERFACE\HUD\HUD_weaponsgroup2.3db';
      2: Model := 'INTERFACE\HUD\HUD_weaponsgroup3.3db';
      else
        Model := nil;
      end;
      Group[I] := THud.CreateButton(Battery.Parent,'HudWeaponGroupButton',Model,0,'ui_select_item',0,
        TD3DVector.Create(Battery.Position.X+0.04+dxGroup*I,Battery.Position.Y-0.122,0),0,
        TD3DVector.Create(0.014,0.014,0),0,1,0,0,0,0,0);
    end;
  end else
  begin
    //?
  end
else
if (Owner <> nil) and Find(Sender,'BatteryCountText',Battery)  then
begin
  for I := 0 to High(Group) do
  begin
    Pos := Battery.Position;
    if Shift then
    begin
      Pos.x := Pos.x + 0.22 + dxGroup*I;
      Pos.y := Pos.y - 0.122 + Delta;
      Pos.z := -0.3;
    end else
    begin
      Pos.x := Pos.x + 0.17 + dxGroup*I;
      Pos.y := Pos.y - 0.122 + Delta;
      Pos.z := -0.3;
    end;
    Group[I].Perform($6,UINT(@Pos),0);
  end;
end;
end;

procedure THudWeaponGroups.Update(const Sender:TControl);
var
I : Integer;
C : TButton;
begin
if (Owner <> nil) and (Sender = Owner) then
begin
  if Find(Owner,'StatusCloseButton',C) then
    if C.Visible then
      Delta := 0.06 else
      Delta := 0;
  if PPointer(CurrentShip)^<>nil then
    for I := 0 to High(Group) do
      Group[I].Perform($C,Integer(Boolean(CurrentGroup^ = I)),0);
end;
end;

procedure THudWeaponGroups.Execute(const Sender:TControl);

  procedure ExecuteAction(const LParam,WParam:UINT);//cdecl?
  asm
    push      eax
    push      edx
    mov       eax,$576410
    call      eax
    add       esp,$08
  end;

var
I : Integer;
begin
if (Owner <> nil) and (Sender.Parent = Owner) then  //WeaponText%d's parent is a HUD_Status
  for I := 0 to High(Group) do
    if Group[I] = Sender then
      case I of
      0: ExecuteAction(1,$91);
      1: ExecuteAction(1,$92);
      2: ExecuteAction(1,$93);
      else
        Break;
      end;
end;

procedure THudWeaponGroups.Terminate(const Sender:TControl);
var
I : Integer;
begin
if Owner = nil then Exit;
if (Sender = Owner) then Reset else
for I := 0 to High(Group) do
    if Group[I] = Sender then
    begin
      Reset;
      Break;
    end;
end;

begin
IsMultiThread := True;
_IHudFacility.AddHud(THudWeaponGroups.Create as IHud);
end.
